# mogo

Use mongodb to store and query data.

# benchmark
environment: 10 Cores, 16GB Mem

### DbWorkerRunning_FindWorkerByModelId
```shell
$ go test -bench BenchmarkDbWorkerRunning_FindWorkerByModelId  -run=none 
init data cost 21.898958542s
goos: darwin
goarch: arm64
pkg: github.com/odysseus/mogo/operator
BenchmarkDbWorkerRunning_FindWorkerByModelId-10                     4824            228639 ns/op
BenchmarkDbWorkerRunning_FindWorkerByModelId_Parallel-10           21433             55233 ns/op
PASS
ok      github.com/odysseus/mogo/operator       30.056s


```

### WorkerInstalledOperator_FindWorkerByModelIdAndGpuMem
```shell
$ go test -bench BenchmarkWorkerInstalledOperator_FindWorkerByModelIdAndGpuMem  -run=none 
init data cost 29.047527667s
goos: darwin
goarch: arm64
pkg: github.com/odysseus/mogo/operator
BenchmarkWorkerInstalledOperator_FindWorkerByModelIdAndGpuMem-10                    6000            233801 ns/op
BenchmarkWorkerInstalledOperator_FindWorkerByModelIdAndGpuMem_Parallel-10          20380             56324 ns/op
PASS
ok      github.com/odysseus/mogo/operator       41.495s

```

### DbWorker_InsertWorker
```shell
$ go test -bench BenchmarkDbWorker_InsertWorker -run=none                                 
goos: darwin
goarch: arm64
pkg: github.com/odysseus/mogo/operator
BenchmarkDbWorker_InsertWorker-10                   1629            772576 ns/op
BenchmarkDbWorker_InsertWorker_Parallel-10          5317            257817 ns/op
PASS
ok      github.com/odysseus/mogo/operator       16.184s

```

### DbWorker_UpdateHardware
```shell
$ go test -bench BenchmarkDbWorker_UpdateHardware -run=none 
init data cost 14.543962959s
goos: darwin
goarch: arm64
pkg: github.com/odysseus/mogo/operator
BenchmarkDbWorker_UpdateHardware-10                         5238            227771 ns/op
BenchmarkDbWorker_UpdateHardware_Parallel-10               45058             26726 ns/op
PASS
ok      github.com/odysseus/mogo/operator       26.082s
```

### DbWorker_UpdateGPUUsage
```shell
$ go test -bench BenchmarkDbWorker_UpdateGPUUsage_Parallel -run=none 
init data cost 11.680798833s
goos: darwin
goarch: arm64
pkg: github.com/odysseus/mogo/operator
BenchmarkDbWorker_UpdateGPUUsage_Parallel-10               39732             30478 ns/op
PASS
ok      github.com/odysseus/mogo/operator       24.462s
```

### DbWorker_FindWorkerByInstallModelAndSortByGpuRam
```shell
$ go test -bench BenchmarkDbWorker_FindWorkerByInstallModelAndSortByGpuRam -run=none 
init data cost 11.454150167s
goos: darwin
goarch: arm64
pkg: github.com/odysseus/mogo/operator
BenchmarkDbWorker_FindWorkerByInstallModelAndSortByGpuRam-10                           8         134020718 ns/op
BenchmarkDbWorker_FindWorkerByInstallModelAndSortByGpuRam_Parallel-10                 46          24041430 ns/op
PASS
ok      github.com/odysseus/mogo/operator       18.358s
```

### DbWorker_FindWorkerByRunningModelAndSortByWaitTime
```shell
$ go test -bench BenchmarkDbWorker_FindWorkerByRunningModelAndSortByWaitTime -run=none 
init data cost 867.106708ms
goos: darwin
goarch: arm64
pkg: github.com/odysseus/mogo/operator
BenchmarkDbWorker_FindWorkerByRunningModelAndSortByWaitTime-10                       528           2272385 ns/op
BenchmarkDbWorker_FindWorkerByRunningModelAndSortByWaitTime_Parallel-10             1125           1024101 ns/op
PASS
ok      github.com/odysseus/mogo/operator       5.886s
```